﻿using System;
using System.Collections.Generic;
using BenchmarkDotNet.Attributes;
using EnumsNET;
using FastEnumUtility.Benchmark.Models;
using _FastEnum = FastEnumUtility.FastEnum;



namespace FastEnumUtility.Benchmark.Scenarios
{
    public class GetValuesBenchmark
    {
        [GlobalSetup]
        public void Setup()
        {
            _ = Enum.GetValues(typeof(Fruits));
            _ = Enums.GetValues<Fruits>();
            _ = _FastEnum.GetValues<Fruits>();
        }


        [Benchmark(Baseline = true)]
        public IReadOnlyList<Fruits> NetCore()
            => (IReadOnlyList<Fruits>)Enum.GetValues(typeof(Fruits));


        [Benchmark]
        public IReadOnlyList<Fruits> EnumsNet()
            => Enums.GetValues<Fruits>();


        [Benchmark]
        public IReadOnlyList<Fruits> FastEnum()
            => _FastEnum.GetValues<Fruits>();
    }
}
